import processing.core.*;
import javax.swing.JOptionPane;
import java.util.*;
//import java.util.Stack;
//import java.util.Queue;

public class GraphBasic extends PApplet{
    //Zu Lehrzwecken werden alle Attribute auf public gesetzt
    //Darstellungsattribute
    public boolean showInfos = true;
    public boolean verschiebbar = true;
 
    //Datenattribute
    public int maxKnoten = 10;
    public Knoten[] knoten = new Knoten[maxKnoten];
    private int[][] adjazenzmatrix = new int[maxKnoten][maxKnoten];
    
    //Algorithmenattribute
    public int startIndex = -1;
    public int zielIndex = -1;
    public ArrayList<Knoten> pfad = new ArrayList<Knoten>();
    public boolean[] besucht = new boolean[maxKnoten];
    public int[] vorgaenger= new int[maxKnoten]; //merkt sich den jweiligen Vorgnger des iten Elements
    public boolean algStarted = false;
    //Attribute fr Animation
    //import java.util.*;
    public Stack<Integer> dfs_stack = new Stack<Integer>(); //Tiefensuche
    public Queue<Integer> bfs_queue = new LinkedList<Integer>(); //Breitensuche
    public int letzterBesuchterKnotenIdx = -1;
    //dfs_stack.pop(),dfs_stack.push(i) 

    
    
    
    public void settings() {
        //Fenstergroesse
        size(640, 360);
    }
    
    public void setup() {
        //frameRate(1);
        init();
    }
    
    public void init() {
        //Erzeugen von Zufallspunkten.
        for (int i = 0; i < knoten.length; i++) {          
          knoten[i] = new Knoten(""+i,random(20,width-20),random(20, height-20));
        }
        
        //Erzeugen der Kanten
        for(int i=0; i < maxKnoten; i++) {
            for(int j=0; j < maxKnoten; j++) {
                if(i == j) { //Diagonale mit Nullen belegen
                    adjazenzmatrix[i][j] = 0;
                } else {
                    int zufallsGewicht = (int)random(1,60);
                    if (zufallsGewicht%3==0) {
                        adjazenzmatrix[i][j] = zufallsGewicht;
                        adjazenzmatrix[j][i] = zufallsGewicht;
                    } else {
                        adjazenzmatrix[i][j] = 0;
                        adjazenzmatrix[j][i] = 0;
                    }
                }
            }
        }
        
        pfad = new ArrayList<Knoten>();
        for (int i=0;i<besucht.length; i++) {
            besucht[i]=false;
        }
        
        vorgaenger= new int[maxKnoten];
        for (int i=0;i<vorgaenger.length; i++) {
            vorgaenger[i]=-1;
        }
        
        startIndex = -1;
        zielIndex = -1;
        algStarted = false;
    }
    
    public void matrixAusgeben() {
        for(int i=0; i < maxKnoten; i++) {
            for(int j=0; j < maxKnoten; j++) {
                System.out.print(adjazenzmatrix[i][j]+"\t");
            }
            System.out.println();
        }
    }
    
    public void keyPressed() {
        if (keyPressed) {
            //Show Infos
            if (key == 'i' || key == 'I') {
                showInfos = !showInfos;
            }
            if (key == 'e' || key == 'E') {
                matrixAusgeben();
            }
            //New Graph
            if (key == 'n' || key == 'N') {
                init();
            }
            if (key == 'm' || key == 'M') {
                verschiebbar = ! verschiebbar;
            }
            if (key == 's' || key == 'S') {
                if (algStarted) {
                    tiefensucheSchrittAnim();
                }
            }
            if (key == 'a' || key == 'A') {
                if (startIndex>=0) {
                    JOptionPane.showMessageDialog(null, "Tiefensuche startet");
                    algStarted = true;
                    //tiefensucheInit();
                    tiefensucheInitAnim();
                }
            }
            if (key == 'h' || key == 'H') {
                String curText = "i: Infos der Knoten anzeigen\n";
                curText += "e: Adjazenzmatrix ausgeben\n";
                curText += "n: Neuen Graph erzeugen.\n";
                curText += "m: Knoten verschiebbar machen.\n";
                curText += "     Anschlieend mit Maus \n";
                curText += "     irgendeinen Knoten verschieben.\n";
                curText += "a: Aktuellen Algorithmus starten.\n";
                curText += "s: Einen Schritt des Algorithmus machen.\n";
                curText += "s+Maus: Startknoten (ent)markieren.\n";
                curText += "t+Maus: Zielknoten (ent)markieren.\n";
                JOptionPane.showMessageDialog(null, curText);
            }
        }
    }
    
    public void mouseDragged() {
        for(Knoten k: knoten) {
            if (abs(k.x-mouseX)<k.radius && abs(k.y-mouseY)<k.radius) {
                //Knoten verschieben
                if (verschiebbar) {
                    k.x=mouseX;
                    k.y=mouseY;
                }
            }
        }
    }
    
    public void mousePressed() {
        for (int i = 0; i < maxKnoten; i++) {
            Knoten k = knoten[i];
            if (abs(k.x-mouseX)<k.radius && abs(k.y-mouseY)<k.radius) {
                if (keyPressed && (key == 's' || key == 'S' )) {
                    if (k.colour.equals("ff00ff00")) { //Gruen
                        k.colour = "ffffffff"; //Weiss
                        startIndex = -1;
                    } else {
                        if (startIndex == -1) {
                            k.colour = "ff00ff00"; //Gruen: Startpunkt
                            startIndex = i;
                        }
                    }
                }
                if (keyPressed && (key == 't' || key == 'T' )) {
                    if (k.colour.equals("ffff0000")) { //Rot
                        k.colour = "ffffffff"; //Weiss
                        zielIndex = -1;
                    } else {
                        if (zielIndex == -1) {
                            k.colour = "ffff0000"; //Rot Ziel(Target)
                            zielIndex = i;
                        }
                    }
                }
            }
        }
    }
    
    //ALGORITHMUS
    //Tiefensuche
    public void tiefensucheSchritt(int aktKnotenIdx) {
        besucht[aktKnotenIdx]=true;
        //System.out.println(knoten[aktKnotenIdx].name);

        for(int i=0; i < maxKnoten; i++) {
            if (adjazenzmatrix[aktKnotenIdx][i]>0 && besucht[i]==false) {
                pfad.add(knoten[i]); //aktuellen Knoten in die Liste des Pfades aufnehmen
                vorgaenger[i] = aktKnotenIdx; //der neue, i-te Knoten hat als Vorganger den aktuellen knoten
                tiefensucheSchritt(i);
            }
        }
    }
    
    public void tiefensucheInit() {
         //Speichert die Indizes der Knoten des aktuell untersuchten Pfades
        if (startIndex>=0) {
            pfad = new ArrayList<Knoten>();
            for (int i=0;i<besucht.length; i++) {
                besucht[i]=false;
            }
        
            vorgaenger= new int[maxKnoten];
            for (int i=0;i<vorgaenger.length; i++) {
                vorgaenger[i]=-1;
            }
            //aktuellen Knoten in die Liste des Pfades aufnehmen
            pfad.add(knoten[startIndex]);
            tiefensucheSchritt(startIndex);
        }
    }
    
    public void tiefensucheInitAnim() {
         //Speichert die Indizes der Knoten des aktuell untersuchten Pfades
        if (startIndex>=0) {
            pfad = new ArrayList<Knoten>();
            for (int i=0;i<besucht.length; i++) {
                besucht[i]=false;
            }
        
            vorgaenger= new int[maxKnoten];
            for (int i=0;i<vorgaenger.length; i++) {
                vorgaenger[i]=-1;
            }
            letzterBesuchterKnotenIdx = -1;
            //aktuellen Knoten in die Liste des Pfades aufnehmen
            pfad.add(knoten[startIndex]);
            //Listen leeren
            dfs_stack = new Stack<Integer>(); //Tiefensuche: Liste der zu besuchhenden Knoten
            dfs_stack.push(startIndex); //StartIIndex wird auf den Stack gelegt.
        }
    }
    
    public void tiefensucheSchrittAnim() {
        //frameRate(1);
        if (dfs_stack.size()>0) {
            //Stack ausgeben
            for(int obj : dfs_stack) {
                System.out.print(obj+" ");
            }
            System.out.println("<");
            
            int aktKnotenIdx = dfs_stack.pop(); //Hole nchsten Knoten vom Stack.
            besucht[aktKnotenIdx]=true;
            pfad.add(knoten[aktKnotenIdx]); //aktuellen Knoten in die Liste des Pfades aufnehmen
            vorgaenger[aktKnotenIdx] = letzterBesuchterKnotenIdx;
            letzterBesuchterKnotenIdx = aktKnotenIdx;    
            for(int i=0; i < maxKnoten; i++) {
                if (adjazenzmatrix[aktKnotenIdx][i]>0 && besucht[i]==false && !dfs_stack.contains(i)) {
                    //Noch nicht besuchte Knoten auf den Stack legen
                    dfs_stack.push(i); 
                }
            }
        } else {
            JOptionPane.showMessageDialog(null, "Tiefensuche beendet");
            //algStarted = false;
        }
        
        //frameRate(30);
    }
    
    public void draw() {
        background(51); //51 ist dunkles Grau, sonst 0...255
        //Kanten zeichnen
        fill(255);
        stroke(255);
        for (int i = 0; i < maxKnoten-1; i++) {
                for (int j = i+1; j < maxKnoten; j++) {
                    if (adjazenzmatrix[i][j]>0 && j>i) { //Nur obere Dreiecksmatrix
                        line(knoten[i].x, knoten[i].y, knoten[j].x, knoten[j].y);
                    }
                }
        }
        
        //Pfad zeichnen
        if (algStarted) {
            stroke(unhex("ffffb82b"));
            fill(unhex("ffffb82b"));
            for (int i = 0; i < maxKnoten; i++) {
                if (vorgaenger[i]>=0) {
                    Knoten vorgaengerKnoten = knoten[vorgaenger[i]]; //Im Vorganegerfeld seteht an der i-ten Stelle der Vroerganger des aktuellen.
                    line(knoten[i].x, knoten[i].y, vorgaengerKnoten.x, vorgaengerKnoten.y);
                }
            }
        }
        
        
       
        //Knoten zeichnen
        fill(255);
        stroke(255);
        for(int i=0; i < maxKnoten; i++) {
            ellipse(knoten[i].x, knoten[i].y, knoten[i].radius, knoten[i].radius);
        }
    
        //Knoten hervorheben
        if (algStarted) {
            //Knoten Hervorheben
            for(int i=0; i < pfad.size(); i++) {
                stroke(unhex(pfad.get(i).hiliteColour));
                fill(unhex(pfad.get(i).hiliteColour));
                ellipse(pfad.get(i).x, pfad.get(i).y, pfad.get(i).radius, pfad.get(i).radius);
            }
        }
        
        //Start und Zielknoten hervorheben
        if (startIndex>0) {
            stroke(unhex(knoten[startIndex].colour));
            fill(unhex(knoten[startIndex].colour));
            ellipse(knoten[startIndex].x, knoten[startIndex].y, knoten[startIndex].radius, knoten[startIndex].radius);
        }

        if (zielIndex>0) {
            stroke(unhex(knoten[zielIndex].colour));
            fill(unhex(knoten[zielIndex].colour));
            ellipse(knoten[zielIndex].x, knoten[zielIndex].y, knoten[zielIndex].radius, knoten[zielIndex].radius);
        }

        
        for(int i=0; i < maxKnoten; i++) {
            //Das Zeigen der Beschreibung verzgert die Ausfuehrung anfangs
            if (showInfos) {
                if (knoten[i].name.length()<2) { //Kurze Namen im Knoten
                    fill(51);
                    text(knoten[i].name, knoten[i].x-3, knoten[i].y+5);
                } else { //lange Namen daneben
                    fill(255);
                    text(knoten[i].name, knoten[i].x+8, knoten[i].y+4);
                }
            }
        }
    }
}